//
//
#include "NEALandELIZA.h"
//#include <esplib.h>
#include "esplib0.h"
#include <ewclib.h>
#include <math.h>

#include <time.h>
#include <direct.h>


//-----NEALandELIZA global
double pitch,dt;
//int px,py;
int aaflg=1;
int pic_num,view_num;
int view_pos=0;
int loop=0;

int WX,WY;
int WX_s=640,WY_s=480;
int DX,DY;

int LCD=3;

int px,py;
int px_pv,py_pv;

int parallax;
int para_x,para_y;
int shift_h,shift_v;

int lenti;

unsigned int *work;



#ifdef OCT_MODE 
#define GR_SIZE char

#else
#define GR_SIZE int

#endif

unsigned int *line_1;
unsigned int *line_2;
unsigned int *line_3;

unsigned GR_SIZE *work_map;

int *pos_map;
int *point_map;
int *th_flg_map;
int *aa_map;
int *aa_pos_map;
double *th_map;

int *point_table;
int *pos_table;
int *aa_table;
int *aa_table_pos;
int *th_flg;
double *th;

unsigned GR_SIZE *display_buff;

int th_test;
//-----end NEALandELIZA global



//int WX_s=640;
//int WY_s=480;
//#define WX 320
//#define WY_s 240
#define SCALE 100
//#define WX 640
//#define WY 480
//#define SCALE 100
//#define WX 640
//#define WY 480
//#define SCALE 50


//#define WX 960
//#define WY 720
//#define SCALE 100

//#define WX 1280
//#define WY 960

//#define FPS 30.0
#define FPS 15.0
//#define FPS 10.0


#define heikin(c0,c1) RGB2C((C2R(c0)+C2R(c1))/2, (C2G(c0)+C2G(c1))/2, (C2B(c0)+C2B(c1))/2)
#define kongou(c0,c1) RGB2C((C2R(c0)|C2R(c1)), (C2G(c0)|C2G(c1)), (C2B(c0)|C2B(c1)))

	int aiaiouea=0;
//	int flg=0;
	int flg=1;

int shift_x,shift_y,paral;



void ESP_Ready(void)

{

#define SCALE2 50
	ESP_CreateImage(0,"Right", 0,0,WX_s,WY_s, SCALE2);
	ESP_CreateImage(1, "Left",(WX_s*SCALE2)/100,0,WX_s,WY_s, SCALE2);

//	ESP_OpenTextWindow(0,0,(WY_s*SCALE)/100,439,135);
//	ESP_OpenTextWindow(0,(WX_s*2*25)/100,(WY_s*SCALE)/100+150,439,135);
//	ESP_OpenTextWindow(0,(WX_s*2*SCALE)/100,0,439,135);
	ESP_OpenTextWindow(0,(WX_s*SCALE)/100,0,439,135);


ESP_Printf("%f\n",pow(120000*8*3,0.5)/3.0);
ESP_Printf("%f\n",pow(120000*8*3,0.5)/8.0);


//WX_s=640;WY_s=480;
	//p̑쐬
    //	ESP_CreateImage(2, "LR", 0, (WY_s*SCALE)/100+150, WX_s*2, WY_s, 25);
    	ESP_CreateImage(2, "LR", 0, 0, WX_s*2, WY_s, SCALE);

	ESP_Printf("...\n");
	int r= EWC_Open(WX_s,WY_s,FPS);
	if(r){
		ESP_Printf("Error %d\n",r);
		return;
	}

	ESP_START=1;
	ESP_MOUSE=1;

//	pitch=9.9383;
	pitch=9.862;
	WX=400;
	WY=300;
	DX=400;
	DY=300;
	pic_num=2;
	view_num=2;

//	ESP_Printf("StartNbNĂD\n");
}


#define XY2PT(x,y,widex) (((y)*(widex))+(x))
//void set_parallax(int source,int dest,int sx,int sy)
void set_parallax()
{
int absx,absy;
int DX;
int WX_s,WY_s;
int WX_d,WY_d;
int Lsx,Rsx,Lsy,Rsy;
//int getax,getay;
//int area;

absx=abs(shift_x);absy=abs(shift_y);
DX=esp_iw[2].wx;
WX_s = esp_iw[0].wx;
WY_s = esp_iw[0].wy;
WX_d = WX_s-absx;
WY_d = WY_s-absy;

if (shift_x>0) {
	Lsx=absx;
	Rsx=0;
} else {
	Lsx=0;
	Rsx=absx;
}
if (shift_y>0) {
	Lsy=absy;
	Rsy=0;
} else {
	Lsy=0;
	Rsy=absy;
}
//getax=absx/2;
//getay=absy/2;

//area = ((x>=getax)&&(x<(WX_d+getax))&&(y>=getay)&&(y<(WY_d+getay)));

for (int y=0;y<WY_s;y++){
	for (int x=0;x<WX_s;x++){
		if ((x>=0)&&(x<WX_d)&&(y>=0)&&(y<WY_d)) {
//		if ((x>=getax)&&(x<(WX_d+getax))&&(y>=getay)&&(y<(WY_d+getay))) {
			ESP_VramPtr[2][XY2PT(x,y,DX)] = ESP_VramPtr[0][XY2PT(x+Lsx,y+Lsy,WX_s)];
//			ESP_VramPtr[2][XY2PT(x+WX_s,y,WX)] = ESP_VramPtr[1][XY2PT(x+WX_s+Rsx,y+Rsy,WX)];
			ESP_VramPtr[2][XY2PT(x+WX_s,y,DX)] = ESP_VramPtr[1][XY2PT(x+Rsx,y+Rsy,WX_s)];
		} else {
			ESP_VramPtr[2][XY2PT(x,y,DX)] = 0x0;
			ESP_VramPtr[2][XY2PT(x+WX_s,y,DX)] = 0x0;
		}
	}
}
//ESP_Update_(dest);
}


void free_mem_alloc()
{
free(line_3);
free(line_2);
free(line_1);

free(th);
free(aa_table_pos);
free(aa_table);
free(th_flg);
free(point_table);
free(pos_table);

free(work_map);
free(th_map);
free(aa_pos_map);
free(aa_map);
free(th_flg_map);
free(point_map);
free(pos_map);

}


void ESP_Main(void)
{
	unsigned int *Left_EYE;
	unsigned int *Right_EYE;
//	int flg=0;
	int gousei=0;
	int mode;
//	int sleep=33;
	int sleep=200;
	int anaglyph=0;
//	int capture=0;
	char fname[256],Sdate[256],Stime[256];
	double d;
	int gamma=0;
	double gamma_d;
//	int aiaiouea=0;
	double V_exposure,V_gain;
//	int waitcap=0;
	int waitcap=1;




	if (flg) {
		Left_EYE  = ESP_VramPtr[1];
		Right_EYE = ESP_VramPtr[0];
	} else {
		Left_EYE  = ESP_VramPtr[0];
		Right_EYE = ESP_VramPtr[1];
	}

//	ESP_OpenButtonBox(0,(WY_s*SCALE)/100+30,11,5);
	ESP_OpenButtonBox(0,30,11,5);
	ESP_SetButtonBoxTitle( 0,"(1)2cm");
	ESP_SetButtonBoxTitle( 1,"(2)90%");
	ESP_SetButtonBoxTitle( 2,"(3)80%");
	ESP_SetButtonBoxTitle( 3,"(4)70%");
	ESP_SetButtonBoxTitle( 4,"(5)5cm");
	ESP_SetButtonBoxTitle( 5,"(6)50%");
	ESP_SetButtonBoxTitle( 6,"(7)40%");
	ESP_SetButtonBoxTitle( 7,"(8)30cm");
	ESP_SetButtonBoxTitle( 8,"(9)20%");
	ESP_SetButtonBoxTitle( 9,"(0)10%");
	ESP_SetButtonBoxTitle(10,"(-)0%");
	ESP_SetButtonBoxTitle(11,"Capture");
	ESP_SetButtonBoxTitle(12,"ConfigLR");
	ESP_SetButtonBoxTitle(13,"ConfigL");
	ESP_SetButtonBoxTitle(14,"Sleep 100");
	ESP_SetButtonBoxTitle(15,"Sleep 133");
	ESP_SetButtonBoxTitle(16,"Sleep 166");
	ESP_SetButtonBoxTitle(17,"Sleep 200");
	ESP_SetButtonBoxTitle(18,"Sleep 233");
	ESP_SetButtonBoxTitle(19,"Sleep 266");
	ESP_SetButtonBoxTitle(20,"Sleep 300");
	ESP_SetButtonBoxTitle(21,"Gousei");
	ESP_SetButtonBoxTitle(22,"(Z)Auto_F");
	ESP_SetButtonBoxTitle(23,"(X)Fix_F");
	ESP_SetButtonBoxTitle(24,"GAMMA 1.0");
	ESP_SetButtonBoxTitle(25,"GAMMA 0.5");
	ESP_SetButtonBoxTitle(26,"GAMMA 0.3");
	ESP_SetButtonBoxTitle(27,"GAMMA 0.2");
	ESP_SetButtonBoxTitle(28,"GAMMA 0.1");
	ESP_SetButtonBoxTitle(29,"anaglyph3");
	ESP_SetButtonBoxTitle(30,"anaglyph2");
	ESP_SetButtonBoxTitle(31,"anaglyph1");
	ESP_SetButtonBoxTitle(32,"swapLR");
	ESP_SetButtonBoxTitle(33,"IN");
	ESP_SetButtonBoxTitle(34,"OUT");
	ESP_SetButtonBoxTitle(35,"Capture");
	ESP_SetButtonBoxTitle(36,"(S)Exp-");
	ESP_SetButtonBoxTitle(37,"(W)Exp+");
	ESP_SetButtonBoxTitle(38,"(Q)Gain-");
	ESP_SetButtonBoxTitle(39,"(A)Gain+");
	ESP_SetButtonBoxTitle(40,"(E)WB parallel");
	ESP_SetButtonBoxTitle(41,"(D)WB sync");
	ESP_SetButtonBoxTitle(42,"wait sync");

	ESP_SetButtonBoxTitle(44,"");
	ESP_SetButtonBoxTitle(45,"");
	ESP_SetButtonBoxTitle(46,"");
	ESP_SetButtonBoxTitle(47,"");
	ESP_SetButtonBoxTitle(48,"parallax");
	ESP_SetButtonBoxTitle(49,"lenti");

	ESP_MOUSE=1;
	srand(time(NULL));

			if (waitcap) while(!EWC_IsCaptured(0));
			EWC_GetImage(0,Right_EYE);
			if (waitcap) while(!EWC_IsCaptured(1));
			EWC_GetImage(1, Left_EYE);

	V_exposure = EWC_GetValue( 0, EWC_EXPOSURE );
	V_exposure = double((int(V_exposure)/5)*5);
	EWC_SetValue( 1, EWC_EXPOSURE, V_exposure);
	V_gain = EWC_GetValue( 0, EWC_GAIN );
	V_gain = double((int(V_gain)/5)*5);
	EWC_SetValue( 1, EWC_GAIN, V_gain);
	ESP_Printf("Exposure: %4.1f%%, Gain: %4.1f%%\n", V_exposure,V_gain);

	for(;;){
		if(ESP_STOP) break;

//
//		if (ESP_CTRL) {capture = 1;			ESP_Printf("ctrl");}
//		if (ESP_SHIFT) capture = 1;
//		if (ESP_ML) ESP_Printf("ML");
		
//		if(EWC_IsCaptured(0)){

		if (!capture){
			ESP_Sleep(sleep);
//			Sleep(sleep);

			if (waitcap) while(!EWC_IsCaptured(0));
			EWC_GetImage(0,Right_EYE);
			if (waitcap) while(!EWC_IsCaptured(1));
			EWC_GetImage(1, Left_EYE);
/*
			while(!EWC_IsCaptured(0));
			EWC_GetImage(0,Right_EYE);
			while(!EWC_IsCaptured(1));
			EWC_GetImage(1, Left_EYE);
*/
			if (gamma){
				int gamma_table[256];
				for(int i=0;i<256;i++) gamma_table[i] = i + (int)((((sqrt(((double)i)/255.0))*255.0)-((double)i))*gamma_d);
				int col,r,g,b;
				for(int i=0;i<WX_s*WY_s;i++){
					col = *(ESP_VramPtr[0]+i);
					r = C2R(col); g = C2G(col); b = C2B(col);
					*(ESP_VramPtr[0]+i) = RGB2C( gamma_table[r], gamma_table[g], gamma_table[b] );
					col = *(ESP_VramPtr[1]+i);
					r = C2R(col); g = C2G(col); b = C2B(col);
					*(ESP_VramPtr[1]+i) = RGB2C( gamma_table[r], gamma_table[g], gamma_table[b] );

				}
			}
		}
			if (capture) {
						time_t timer;
						struct tm *date;

					    timer = time(NULL);          /* oߎԂ擾 */
						date = localtime(&timer);    /* oߎԂԂ\\ date ɕϊ */

						ESP_Select(2);
						//J摜p̑֓]
						if (flg) {
							ESP_PutWindow( Right_EYE,  0, 0, WX_s, WY_s);
							ESP_PutWindow(  Left_EYE, WX_s, 0, WX_s, WY_s);
						} else {
							ESP_PutWindow(  Left_EYE,  0, 0, WX_s, WY_s);
							ESP_PutWindow( Right_EYE, WX_s, 0, WX_s, WY_s);
						}
						ESP_Update_(2);

						if (aiaiouea){
							char targetdir[256];
//							strftime(Sdate, 255, "%y%m%d%H%M%S", date);
							strftime(Sdate, 255, "%y%m%d", date);
							_mkdir(Sdate);
							strftime(Stime, 255, "%H%M%S", date);
							sprintf(targetdir, "%s\\%s",Sdate, Stime);
							_mkdir(targetdir);
							sprintf(fname, "%s\\orig",targetdir);
							ESP_Printf("%s\n", fname);
							ESP_ImageSave(ESP_JPEG,fname,0,0,WX_s*2,WY_s);

//							srand(time(NULL));
							ESP_Printf("%04d\n", rand());
							FILE *fp;
							sprintf(fname, "%s\\date.txt",targetdir);
							fp=fopen(fname,"w");
							fprintf(fp,"%s",Sdate);
							fclose(fp);

							sprintf(fname, "%s\\user.txt",targetdir);
							fp=fopen(fname,"w");
							fprintf(fp,"%s",Stime);
							fclose(fp);

							sprintf(fname, "%s\\pass.txt",targetdir);
							fp=fopen(fname,"w");
							fprintf(fp,"%04d",rand());
							fclose(fp);

						} else {
							strftime(fname, 255, "%y%m%d_%H_%M_%S", date);
							ESP_Printf("%s\n", fname);
							ESP_ImageSave(ESP_JPEG,fname,0,0,WX_s*2,WY_s);
						}
						capture = 0;
			}


			if (gousei){
				for(int i=0;i<WX_s*WY_s;i++){
					*(ESP_VramPtr[0]+i) = heikin(*(ESP_VramPtr[0]+i),*(ESP_VramPtr[1]+i));
				}
			}
			if (anaglyph == 3){
				int col,r,g,b;
				for(int i=0;i<WX_s*WY_s;i++){
					if (flg){
						col = *(ESP_VramPtr[0]+i);
						C2RGB(col,&r,&g,&b);
						r = (int)(0.299*r+0.587*g+0.114*b);
						*(ESP_VramPtr[0]+i) = RGB2C(r,0,0);
						col = *(ESP_VramPtr[1]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[1]+i) = RGB2C(0,g,b);
					} else {
						col = *(ESP_VramPtr[0]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[0]+i) = RGB2C(0,g,b);
						col = *(ESP_VramPtr[1]+i);
						C2RGB(col,&r,&g,&b);
						r = (int)(0.299*r+0.587*g+0.114*b);
						*(ESP_VramPtr[1]+i) = RGB2C(r,0,0);
					}


					*(ESP_VramPtr[0]+i) = kongou(*(ESP_VramPtr[0]+i),*(ESP_VramPtr[1]+i));
				}
			}

			if (anaglyph == 2){
				int col,r,g,b;
				for(int i=0;i<WX_s*WY_s;i++){
					if (flg){
						col = *(ESP_VramPtr[0]+i);
//						C2RGB(col,&r,&g,&b);
//						C2HSV(col,&b,&g,&r);
						r = C2V(col);
//						r = C2Y(col);//same as anaglyph 3
						*(ESP_VramPtr[0]+i) = RGB2C(r,0,0);
						col = *(ESP_VramPtr[1]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[1]+i) = RGB2C(0,g,b);
					} else {
						col = *(ESP_VramPtr[0]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[0]+i) = RGB2C(0,g,b);
						col = *(ESP_VramPtr[1]+i);
//						C2RGB(col,&r,&g,&b);
//						C2HSV(col,&b,&g,&r);
						r = C2V(col);
//						r = C2Y(col);//same as anaglyph 3
						*(ESP_VramPtr[1]+i) = RGB2C(r,0,0);
					}


					*(ESP_VramPtr[0]+i) = kongou(*(ESP_VramPtr[0]+i),*(ESP_VramPtr[1]+i));
				}
			}

			if (anaglyph == 1){
				int col,r,g,b;
				for(int i=0;i<WX_s*WY_s;i++){
					if (flg){
						col = *(ESP_VramPtr[0]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[0]+i) = RGB2C(r,0,0);
						col = *(ESP_VramPtr[1]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[1]+i) = RGB2C(0,g,b);
					} else {
						col = *(ESP_VramPtr[0]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[0]+i) = RGB2C(0,g,b);
						col = *(ESP_VramPtr[1]+i);
						C2RGB(col,&r,&g,&b);
						*(ESP_VramPtr[1]+i) = RGB2C(r,0,0);
					}


					*(ESP_VramPtr[0]+i) = kongou(*(ESP_VramPtr[0]+i),*(ESP_VramPtr[1]+i));
				}
			}
//				for(int i=0;i<WX_s*WY_s;i++){
//					*(ESP_VramPtr[2]+i) = heikin(*(ESP_VramPtr[0]+i),*(ESP_VramPtr[1]+i));
//				}

/*			
				for (int y=0;y<WY_s;y++) {
                    for (int x=0;x<WX_s;x++) {
                        if (x<WX_s/2) {
                            *(ESP_VramPtr[2]+x+WX_s*y) = *(ESP_VramPtr[0]+x*2+WX_s*y);
                        } else {
                            *(ESP_VramPtr[2]+x+WX_s*y) = *(ESP_VramPtr[1]+(x-WX_s/2)*2+WX_s*y);
                        }
                    }
                }
*/

		if (paral){
			set_parallax();
		} else {
			ESP_Select(2);
			ESP_PutWindow(ESP_VramPtr[0],0,0,WX_s,WY_s);
			ESP_PutWindow(ESP_VramPtr[1],WX_s,0,WX_s,WY_s);
		}
			ESP_Update_(2);
			

			if (lenti){

//				ResizeNN_int(work, work_map, WX_s*pic_num,WY_s,WX*pic_num*LCD,WY/LCD);
				ResizeNN_int(ESP_VramPtr[2], work_map, WX_s*pic_num,WY_s,WX*pic_num*LCD,WY/LCD);
//				ResizeNN_int(ESP_VramPtr[PREVIEW], work_map, WX_s*pic_num,WY_s,WX*pic_num*LCD,WY/LCD);
				draw_LCD_main();
				ESP_Update_(3);
			}

//			ESP_Select(0);ESP_Update();
//			ESP_Select(1);ESP_Update();
//			ESP_Printf("*");

//			if (ESP_CTRL) capture = 1;

			for (int b=0; b<55; b++){
				if(ESP_GetButtonBox(b)){
//				double d;
				double prop_Value;
				switch(b){
					case 11: //capture
						capture = 1;
						break;
					case 12: //config
//						int mode;
						EWC_PropertyPage(0);
						//J0̐ݒJ1ɃRs[
						for  (int num=0; num<17; num++) {
							d = EWC_GetValue(0, num, &mode);
							if (mode) { //[h
								EWC_SetAuto( 1, num);
							} else {
								if ( d != -1.0 ) {
									EWC_SetValue(1, num, d);
								}
							}
						}
						break;
					case 13: //J1̊mFp
						EWC_PropertyPage(1);
						break;

					case 14: //
						sleep=100;
						break;
					case 15: //
						sleep=133;
						break;
					case 16: //
						sleep=166;
						break;
					case 17: //
						sleep=200;
						break;
					case 18: //
						sleep=233;
						break;
					case 19: //
						sleep=266;
						break;
					case 20: //
						sleep=300;
						break;

					case 21: //gousei
						if (gousei) gousei=0; else gousei=1;
						if (anaglyph) anaglyph=0;
						break;
					case 22: //auto focus
						EWC_SetAuto(0, EWC_FOCUS);
						EWC_SetAuto(1, EWC_FOCUS);
						ESP_Printf("Focus: auto\n" );
						break;
					case 23: //focus fix
						prop_Value = EWC_GetValue( 0, EWC_FOCUS );
//						d=EWC_GetValue(0, EWC_FOCUS);
						EWC_SetValue(0, EWC_FOCUS, prop_Value);
						EWC_SetValue(1, EWC_FOCUS, prop_Value);
						ESP_Printf("Focus: %4.1f%%\n", prop_Value );
						break;
					case 24: //gamma
						if (gamma != 1) {gamma=1; gamma_d=1.0;} else gamma=0;
						break;
					case 25: //gamma2
						if (gamma != 2) {gamma=2; gamma_d=0.5;} else gamma=0;
						break;
					case 26: //gamma2
						if (gamma != 3) {gamma=3; gamma_d=0.3;} else gamma=0;
						break;
					case 27: //gamma2
						if (gamma != 4) {gamma=4; gamma_d=0.2;} else gamma=0;
						break;
					case 28: //gamma2
						if (gamma != 5) {gamma=5; gamma_d=0.1;} else gamma=0;
						break;
					case 29: //anaglyph3
						if (anaglyph != 3) anaglyph=3; else anaglyph=0;
						if (gousei) gousei=0;
						break;
					case 30: //anaglyph2
						if (anaglyph != 2) anaglyph=2; else anaglyph=0;
						if (gousei) gousei=0;
						break;
					case 31: //anaglyph1
						if (anaglyph != 1) anaglyph=1; else anaglyph=0;
						if (gousei) gousei=0;
						break;
					case 32: //swap
						unsigned int *tmp;
						tmp = Left_EYE;
						Left_EYE = Right_EYE;
						Right_EYE = tmp;
						if (flg) flg=0; else flg=1;
						break;
					case 33:
						if (aiaiouea==0) {
							aiaiouea=1;
							ESP_Printf("aiaaiouea mode in\n");
						}
						break;
					case 34:
						if (aiaiouea) {
							aiaiouea=0;
							ESP_Printf("aiaaiouea mode out\n");
						}
						break;
					case 35:
						capture = 1;
						break;
					case 36://exposure--
//						if (V_exposure>0) {
						if (int(V_exposure)>0) {
							V_exposure -= 5.0;
//							if (V_exposure<0) V_exposure=0.0;
							if (int(V_exposure)<0) V_exposure=0.0;
							EWC_SetValue( 0, EWC_EXPOSURE, V_exposure);
							EWC_SetValue( 1, EWC_EXPOSURE, V_exposure);
						}
						ESP_Printf("Exposure: %4.1f%%, Gain: %4.1f%%\n", V_exposure,V_gain);
						break;
					case 37://exposure++
//						if (V_exposure<100) {
						if (int(V_exposure)<100) {
							V_exposure += 5.0;
//							if (V_exposure>100) V_exposure=100.0;
							if (int(V_exposure)>100) V_exposure=100.0;
							EWC_SetValue( 0, EWC_EXPOSURE, V_exposure);
							EWC_SetValue( 1, EWC_EXPOSURE, V_exposure);
						}
						ESP_Printf("Exposure: %4.1f%%, Gain: %4.1f%%\n", V_exposure,V_gain);
						break;
					case 38://gain--
//						if (V_gain>0) {
						if (int(V_gain)>0) {
							V_gain -= 5.0;
//							if (V_gain<0) V_gain=0.0;
							if (int(V_gain)<0) V_gain=0.0;
							EWC_SetValue( 0, EWC_GAIN, V_gain);
							EWC_SetValue( 1, EWC_GAIN, V_gain);
						}
						ESP_Printf("Exposure: %4.1f%%, Gain: %4.1f%%\n", V_exposure,V_gain);
						break;
					case 39://gain++
//						if (V_gain<100) {
						if (int(V_gain)<100) {
							V_gain += 5.0;
//							if (V_gain>100) V_gain=100.0;
							if (int(V_gain)>100) V_gain=100.0;
							EWC_SetValue( 0, EWC_GAIN, V_gain);
							EWC_SetValue( 1, EWC_GAIN, V_gain);
						}
						ESP_Printf("Exposure: %4.1f%%, Gain: %4.1f%%\n", V_exposure,V_gain);
						break;
					case 40://whitebalance parallel auto
						ESP_Printf("Set Whitebalance [parallel]\n" );
						EWC_SetAuto( 0, EWC_WHITEBALANCE );
						EWC_SetAuto( 1, EWC_WHITEBALANCE );
						Sleep(1000);
						prop_Value = EWC_GetValue( 0, EWC_WHITEBALANCE );
						EWC_SetValue( 0, EWC_WHITEBALANCE, prop_Value );
						ESP_Printf("Whitebalance0: %4.1f%%\n", prop_Value );
						prop_Value = EWC_GetValue( 1, EWC_WHITEBALANCE );
						EWC_SetValue( 1, EWC_WHITEBALANCE, prop_Value );
						ESP_Printf("Whitebalance1: %4.1f%%\n", prop_Value );
						break;
					case 41://whitebalance sync auto
						ESP_Printf("Set Whitebalance [sync]\n" );
						EWC_SetAuto( 0, EWC_WHITEBALANCE );
						Sleep(1000);
						prop_Value = EWC_GetValue( 0, EWC_WHITEBALANCE );
						EWC_SetValue( 0, EWC_WHITEBALANCE, prop_Value );
						EWC_SetValue( 1, EWC_WHITEBALANCE, prop_Value );
						ESP_Printf("Whitebalance: %4.1f%%\n", prop_Value );
						break;
					case 42://wait sync
						if (waitcap) {
							waitcap=0;
							ESP_Printf("wait sync off\n");
						} else {
							waitcap=1;
							ESP_Printf("wait sync on\n");
						}
						break;
					case 44://paraup
						shift_y--;
						ESP_Printf("shift_v: %d\n",shift_y);
						break;
					case 45://paraup
						shift_y++;
						ESP_Printf("shift_v: %d\n",shift_y);
						break;
					case 46://paraup
						shift_x--;
						ESP_Printf("shift_h: %d\n",shift_x);
						break;
					case 47://paraup
						shift_x++;
						ESP_Printf("shift_h: %d\n",shift_x);
						break;
					case 48://paraup
						paral = !paral;
						if (paral)
							ESP_Printf("parallax: on\n");
						else
							ESP_Printf("parallax: off\n");
						break;

					case 49://
						lenti = !lenti;
						if (lenti){

					    	ESP_CreateImage(3, "display", 0, 0, DX, DY, 100);




		if ( (pos_map = (int *)malloc( (MAP_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: pos_map\n");
			goto err_pos_map;
		}
		if ( (point_map = (int *)malloc( (MAP_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: point_map\n");
			goto err_point_map;
		}
		if ( (th_flg_map = (int *)malloc( (MAP_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: th_flg_map\n");
			goto err_th_flg_map;
		}
		if ( (aa_map = (int *)malloc( (MAP_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: aa_map\n");
			goto err_aa_map;
		}
		if ( (aa_pos_map = (int *)malloc( (MAP_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: aa_pos_map\n");
			goto err_aa_pos_map;
		}
		if ( (th_map = (double *)malloc( (MAP_BUFFER_SIZE) * sizeof(double) )) == NULL ) {
			ESP_Printf("malloc: th_map\n");
			goto err_th_map;
		}

		if ( (work_map = (unsigned GR_SIZE *)malloc( ((WX*LCD*pic_num)*(WY/LCD)) * sizeof(unsigned GR_SIZE) )) == NULL ) {
			ESP_Printf("malloc: work\n");
			goto err_work;
		}


		if ( (pos_table = (int *)malloc( (TABLE_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: pos_table\n");
			goto err_pos_table;
		}
		if ( (point_table = (int *)malloc( (TABLE_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: point_table\n");
			goto err_point_table;
		}
		if ( (th_flg = (int *)malloc( (TABLE_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: th_flg_table\n");
			goto err_th_flg_table;
		}
		if ( (aa_table = (int *)malloc( (TABLE_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: aa_table\n");
			goto err_aa_table;
		}
		if ( (aa_table_pos = (int *)malloc( (TABLE_BUFFER_SIZE) * sizeof(int) )) == NULL ) {
			ESP_Printf("malloc: aa_pos_table\n");
			goto err_aa_pos_table;
		}
		if ( (th = (double *)malloc( (TABLE_BUFFER_SIZE) * sizeof(double) )) == NULL ) {
			ESP_Printf("malloc: th_tablep\n");
			goto err_th_table;
		}

		if ( (line_1 = (unsigned int *)malloc( (LINE_BUFFER_SIZE) * sizeof(unsigned int) )) == NULL ) {
			ESP_Printf("malloc: line_1\n");
			goto err_line_1;
		}
		if ( (line_2 = (unsigned int *)malloc( (LINE_BUFFER_SIZE) * sizeof(unsigned int) )) == NULL ) {
			ESP_Printf("malloc: line_2\n");
			goto err_line_2;
		}
		if ( (line_3 = (unsigned int *)malloc( (LINE_BUFFER_SIZE) * sizeof(unsigned int) )) == NULL ) {
			ESP_Printf("malloc: line_3\n");
			goto err_line_3;
		}
/*
//		if ( (display_buff = (unsigned GR_SIZE *)malloc( (WX*(WY+1)) * sizeof(unsigned GR_SIZE) )) == NULL ) {
		if ( (display_buff = (unsigned GR_SIZE *)malloc( (WX*WY) * sizeof(unsigned GR_SIZE) )) == NULL ) {
			ESP_Printf("malloc: display_buff\n");
			goto err_display_buff;
		}
*/
//---------

		display_buff=ESP_VramPtr[3];
		mk_LCDmap_notrev();


						} else {
							free_mem_alloc();
							ESP_DestroyImage(3);
						}
						break;






					default: //focus:{^1`10
						if (b<11) {
							EWC_SetValue( 0, EWC_FOCUS, 100-b*10);
							EWC_SetValue( 1, EWC_FOCUS, 100-b*10);
							ESP_Printf("Focus: %d%%\n", 100-b*10);
						}
				}
				}
			}

//	}
	}
	ESP_Printf("Stop\n");
if (lenti){
end:

//err_display_buff:
//free(display_buff);

err_line_3:
free(line_3);
err_line_2:
free(line_2);
err_line_1:
free(line_1);

err_th_table:
free(th);
err_aa_pos_table:
free(aa_table_pos);
err_aa_table:
free(aa_table);
err_th_flg_table:
free(th_flg);
err_point_table:
free(point_table);
err_pos_table:
free(pos_table);

err_work:
free(work_map);
err_th_map:
free(th_map);
err_aa_pos_map:
free(aa_pos_map);
err_aa_map:
free(aa_map);
err_th_flg_map:
free(th_flg_map);
err_point_map:
free(point_map);
err_pos_map:
free(pos_map);
}
}

void ESP_Finish(void)
{
	EWC_Close();
}
